/*	This file contains the neccessary data for editing the BEAMSPEC.DAT file.  
WARNING:  Very sensetive Data.  Must total 360 bytes */

#ifndef FSTREAM_H
#define FSTREAM_H

#include <fstream.h>
#endif

#ifndef BEAMSPEC_H
#define BEAMSPEC_H

typedef short word;
typedef long dword;

class VBeamSpec
{
private:
	char name[20];
	word cost;
	word tritanium;
	word duranium;
	word molybdenum;
	word mass;
	word tech_level;
	word kill;
	word damage;
public:
	char* GetName()
	{
		char* PName = name;
		return PName;
	}
	short GetCost() { return cost; }
	short GetTritanium() { return tritanium; }
	short GetDuranium() { return duranium; }
	short GetMolybdenum() { return molybdenum; }
	short GetMass() { return mass; }
	short GetTechLevel() { return tech_level; }
	short GetKillLevel() { return kill; }
	short GetDamage() { return damage; }
	void SetName(char* NName)
	{
		for(int i=0; i<20; i++)
		{
			name[i] = *NName;
			NName++;
		}
	}
	void SetCost(short newCost) { cost = newCost; }
	void SetTritanium(short newTri) { tritanium = newTri; }
	void SetDuranium(short newDur) { duranium = newDur; }
	void SetMolybdenum(short newMoly) { molybdenum = newMoly; }
	void SetMass(short newMass) { mass = newMass; }
	void SetTechLevel(short newLevel) { tech_level = newLevel; }
	void SetKill(short newKill) { kill = newKill; }
	void SetDamage(short newDamage) { damage = newDamage; }
	void readFile(int pos, char* filename)
	{
		ifstream infile(filename, ios::binary);
		infile.seekg(pos*sizeof(VBeamSpec));
		infile.read((char*)this, sizeof(*this) );
	}

	void writeFile(int pos)
	{
		ofstream outfile("BEAMSPEC.DAT", ios::binary);
		outfile.seekp(pos*sizeof(VBeamSpec));
		outfile.write((char*)this, sizeof(*this));
	}
};

#endif
