//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TFirstScreen : public TForm
{
__published:	// IDE-managed Components
    TTreeView *TreeList;
    TPanel *Toolbar;
    TSpeedButton *SpeedButton1;
    TBevel *Bevel2;
    TMainMenu *MainMenu1;
    TMenuItem *FileMen;
    TMenuItem *FSave;
    TMenuItem *FBorder;
    TMenuItem *FExit;
    TLabel *HullName;
    TLabel *Cost;
    TLabel *TubeMax;
    TLabel *NumFight;
    TLabel *Cargo;
    TLabel *TechLevel;
    TLabel *MassLab;
    TLabel *Crew;
    TLabel *MolyLab;
    TLabel *DurLab;
    TLabel *TriLab;
    TLabel *BeamNum;
    TLabel *EngNum;
    TLabel *TankSize;
    TEdit *Name;
    TEdit *FuelTank;
    TEdit *NumEngine;
    TEdit *NumBeams;
    TEdit *TriBox;
    TEdit *DurBox;
    TEdit *MolyBox;
    TEdit *CrewSize;
    TEdit *MassBox;
    TEdit *TechBox;
    TEdit *CargoBox;
    TEdit *FighterBaysBox;
    TEdit *TubeBox;
    TEdit *CostBox;
    TBevel *Bevel1;
    TCheckBox *ColoniesCheck;
    TCheckBox *RebelCheck;
    TCheckBox *BotCheck;
    TCheckBox *EmpireCheck;
    TCheckBox *CrystalCheck;
    TCheckBox *CyborgCheck;
    TCheckBox *PrivCheck;
    TCheckBox *FascistCheck;
    TCheckBox *BirdCheck;
    TCheckBox *LizardCheck;
    TCheckBox *FedCheck;
    TRadioGroup *AuxType;
    TLabel *Label1;
    TEdit *PictureBox;
    TLabel *Labelx;
    TMenuItem *Help;
    TMenuItem *HelpAbout;
    void __fastcall AuxTypeClick(TObject *Sender);
    void __fastcall TreeListChange(TObject *Sender, TTreeNode *Node);
    void __fastcall FSaveClick(TObject *Sender);
    void __fastcall FExitClick(TObject *Sender);
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall HelpAboutClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    void __fastcall LoadHullData(TObject *Sender, int filenum = 0);
    void __fastcall LoadTreeView(TObject* Sender);
    void __fastcall CheckTrueHullBox(TObject* Sender, int raceNum);
    void __fastcall HullSave(TObject* Sender);
    __fastcall TFirstScreen(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFirstScreen *FirstScreen;
//---------------------------------------------------------------------------
#endif
