/*	Another Fixed size file.  This one must be 6300 bytes long */

#ifndef FSTREAM_H
#define FSTREAM_H

#include <fstream.h>
#endif

#ifndef STRING_H
#define STRING_H

#include <string.h>
#endif

#ifndef HULLSPECS_H
#define HULLSPECS_H

typedef short word;
typedef long dword;

class VHullSpec
{
private:
	char name[30];
	word picture;
	word image;
	word tritanium;
	word duranium;
	word molybdenum;
	word tank_size;						// size of fuel tank
	word crew_size;
	word num_engines;
	word mass;
	word tech_level;
	word cargo;
	word num_bays;						// number of fighter bays
	word max_torpedoeL;
	word max_beams;
	word cost;
public:
	char* GetName() { char* PName = name; return PName; }
	short GetPicture() { return picture; }
	short GetTritanium() {return tritanium; }
	short GetDuranium() {return duranium; }
	short GetMolybdenum() { return molybdenum; }
	short GetTankSize() {return tank_size; }
	short GetCrewSize() { return crew_size; }
	short GetNumberOfEngines() { return num_engines; }
	short GetMass() { return mass; }
	short GetTechLevel() { return tech_level; }
	short GetCargoSpace() { return cargo; }
	short GetNumberOfFighterBays() { return num_bays; }
	short GetMaxTorpedoeL() { return max_torpedoeL; }
	short GetMaxBeams() { return max_beams; }
	short GetCost() { return cost; }

	void SetName(char* NName)
    {
        for(int i=0; i<30; i++)
        {
            name[i] = *NName;
            NName++;
        }
    }
	void SetPicture(short picNum) { picture = picNum; }
	void SetCost(short newCost) { cost = newCost; }
	void SetTritanium(short newTri) { tritanium = newTri; }
	void SetDuranium(short newDur) { duranium = newDur; }
	void SetMolybdenum(short newMoly) { molybdenum = newMoly; }
	void SetTankSize(short newSize) { tank_size = newSize; }
	void SetCrewSize(short newSize) { crew_size = newSize; }
	void SetNumberOfEngines(short newNum) { num_engines = newNum; }
	void SetMass(short newMass) { mass = newMass; }
	void SetTechLevel(short newLevel) { tech_level = newLevel; }
	void SetCargo(short newCargo) { cargo = newCargo; }
	void SetNumberOfBays(short newNum) { num_bays = newNum; }
	void SetMaxTorpedoeL(short newMax) { max_torpedoeL = newMax; }
	void SetMaxBeams(short newMax) { max_beams = newMax; }

	void readFile(int pos)
	{
		ifstream infile("HULLSPEC.DAT", ios::binary);
		infile.seekg(pos*sizeof(VHullSpec));
		infile.read((char*)this, sizeof(*this) );
	}

	void writeFile(int pos)
	{
		ofstream outfile("HULLSPEC.DAT", ios::binary);
		outfile.seekp(pos*sizeof(VHullSpec));
		outfile.write((char*)this, sizeof(*this));
	}

    bool checkValue()
    {
        if(strlen(name) > 30)
            return 0;
        else
            return 1;
    }
};

#endif