//	The last fixed-size data file.  Torpedoes 

#ifndef FSTREAM_H
#define FSTREAM_H
#include <fstream.h>
#endif

#ifndef TORPSPEC_H
#define TORPSPEC_H

typedef short word;
typedef long dword;

class VTorpSpec
{
private:
	char name[20];
	word cost_torp;
	word cost_launcher;
	// the below are for the launcher.  Torps always take 1 per mineral and have a mass of 1 kt
	word tritanium;
	word duranium;
	word molybdenum;
	word mass;
	word tech_level;
	word kill;
	word damage;
public:
	char* GetName() { char* PName = name; return PName; }
	short GetTorpCost() { return cost_torp; }
	short GetLauncherCost() { return cost_launcher; }
	short GetTritanium() { return tritanium; }
	short GetDuranium() { return duranium; }
	short GetMolybdenum() { return molybdenum; }
	short GetMass() { return mass; }
	short GetTechLevel() { return tech_level; }
	short GetKill() { return kill; }
	short GetDamage() { return damage; }

	void SetName(char* NName) 
	{
		for(int i=0; i<20; i++)
		{
			name[i] = *NName;
			NName++;
		}
	}
	void SetTorpCost(short newCost) { cost_torp = newCost; }
	void SetLauncherCost(short newCost) { cost_launcher = newCost; }
	void SetTritanium(short newTri) { tritanium = newTri; }
	void SetDuranium(short newDur) { duranium = newDur; }
	void SetMolybdenum(short newMoly) { molybdenum = newMoly; }
	void SetMass(short newMass) { mass = newMass; }
	void SetTechLevel(short newLevel) { tech_level = newLevel; }
	void SetKill(short newKill) { kill = newKill; }
	void SetDamage(short newDamage) { damage = newDamage; }

	void readFile(int pos, char* filename)
	{
		ifstream infile(filename, ios::binary);
		infile.seekg(pos*sizeof(VTorpSpec));
		infile.read((char*)this, sizeof(*this) );
	}

	void writeFile(int pos)
	{
		ofstream outfile("TORPSPEC.DAT", ios::binary);
		outfile.seekp(pos*sizeof(VTorpSpec));
		outfile.write((char*)this, sizeof(*this));
	}
};

#endif